/*
 *   Copyright 2012 Joshua AMAVI, Alexandre BOREL, Béatrice BOUCHOU, Agata SAVARY
 *   <joshua.amavi@gmail.com><beatrice.bouchou@univ-tours.fr><agata.savary@univ-tours.fr>
 *
 *   This file is part of XMLCorrector.
 *
 *   XMLCorrector is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   XMLCorrector is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public License,
 *   along with XMLCorrector.  If not, see <http://www.gnu.org/licenses/>.
*/

package fr.ufrt.xmlcorrector.vocabtranslator;

import fr.ufrt.xmlcorrector.exceptions.*;

/**
 * Class BiHashtableRun.
 * 
 * @author Joshua AMAVI
 * @author Alexandre BOREL
 * @author Béatrice BOUCHOU
 * @author Agata SAVARY
 */
public class BiHashtableRun {

	public static void main(String[] args) throws xmlVocabularySizeTooBig {

		BiHashtable bh = new BiHashtable(0);

		// bh.associate("AUTHOR", 'a');
		// bh.associate("TITLE", 'b');
		// bh.associate("EDITOR", 'c');
		// bh.associate("BIBLIO_ENTRY", 'd');

		bh.addString("AUTHOR");
		bh.addString("TITLE");
		bh.addString("EDITOR");
		bh.addString("BIBLIO_ENTRY");

		System.out.println("'AUTHOR' is assigned to '" + bh.getChar("AUTHOR")
				+ "'");
		System.out.println("'TITLE' is assigned to '" + bh.getChar("TITLE")
				+ "'");
		System.out.println("'EDITOR' is assigned to '" + bh.getChar("EDITOR")
				+ "'");
		System.out.println("'BIBLIO_ENTRY' is assigned to '"
				+ bh.getChar("BIBLIO_ENTRY") + "'");

		System.out.println("'a' is assigned to '" + bh.getString('a') + "'");
		System.out.println("'b' is assigned to '" + bh.getString('b') + "'");
		System.out.println("'c' is assigned to '" + bh.getString('c') + "'");
		System.out.println("'d' is assigned to '" + bh.getString('d') + "'");

		System.out.println("\nVocabulary translator test completed!");
	}

}
