package fr.ufrt.xmlcorrector.vue;

import java.io.IOException;
import java.io.Reader;
import java.io.StringReader;

public class BasicParser {
	private int currentChar;
	private final Reader reader;

	public BasicParser(String s) {
		reader = new StringReader(s);
		readNext(); // on se place sur le premier caractere
	}

	public final boolean isAtEnd() {
		return currentChar == -1;
	}

	public final char currentChar() {
		return (char) currentChar;
	}

	public final void readNext() {
		if (isAtEnd())
			throw new RuntimeException("at end");
		try {
			currentChar = reader.read();
		} catch (IOException e) {
			throw new RuntimeException(e.getMessage());
		}
	}

}
