package fr.ufrt.xmlcorrector.vue;

import java.awt.*;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.*;

import fr.ufrt.xmlcorrector.observer.Observer;

public class ProgressBar extends JPanel implements Observer {

	/**
	 * 
	 */
	private static final long serialVersionUID = 531909757169393474L;
	private JProgressBar progressBar;
	private JTextArea taskOutput;
	private JFrame frame;
	private Thread t;

	public ProgressBar(Thread t) {
		super(new BorderLayout());
		this.t = t;
		// Create the demo's UI.
		progressBar = new JProgressBar(0, 100);
		// progressBar.setValue(0);
		// progressBar.setStringPainted(true);
		// progressBar.setString("");
		progressBar.setIndeterminate(true);
		progressBar.setPreferredSize(new Dimension(250, 20));

		taskOutput = new JTextArea(5, 20);
		taskOutput.setMargin(new Insets(5, 5, 5, 5));
		taskOutput.setEditable(false);

		JPanel panel = new JPanel();
		panel.add(progressBar);

		add(panel, BorderLayout.PAGE_START);
		add(new JScrollPane(taskOutput), BorderLayout.CENTER);
		setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));

	}

	/**
	 * Create the GUI and show it. As with all GUI code, this must run on the
	 * event-dispatching thread.
	 */
	public void createAndShowGUI() {
		// Create and set up the window.
		frame = new JFrame("ProgressBar");
		// frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		frame.setLocationRelativeTo(null);
		// frame.setResizable(false);

		// Create and set up the content pane.
		JComponent newContentPane = new ProgressBar(t);
		newContentPane.setOpaque(true); // content panes must be opaque
		frame.setContentPane(this);

		frame.addWindowListener(new closeFrame());

		// Display the window.
		frame.pack();
		frame.setVisible(true);

	}

	public void closeGUI() {
		frame.setVisible(false);
	}

	public void updateOutput(String msg) {
		taskOutput.append(msg + "\n");
	}

	public void update(String msg) {
		taskOutput.append(msg + "\n");

	}

	class closeFrame implements WindowListener {

		@Override
		public void windowActivated(WindowEvent e) {
			// TODO Auto-generated method stub

		}

		@Override
		public void windowClosed(WindowEvent e) {
			// TODO Auto-generated method stub

		}

		@SuppressWarnings({ "static-access", "deprecation" })
		@Override
		public void windowClosing(WindowEvent e) {
			t.stop();
			JOptionPane jop = new JOptionPane();
			jop.showMessageDialog(null, "The operation was stopped !!!",
					"Error", JOptionPane.ERROR_MESSAGE);

		}

		@Override
		public void windowDeactivated(WindowEvent e) {
			// TODO Auto-generated method stub

		}

		@Override
		public void windowDeiconified(WindowEvent e) {
			// TODO Auto-generated method stub

		}

		@Override
		public void windowIconified(WindowEvent e) {
			// TODO Auto-generated method stub

		}

		@Override
		public void windowOpened(WindowEvent e) {
			// TODO Auto-generated method stub

		}

	}

}
